insert into ld_menu (ld_id,ld_lastmodified,ld_deleted,ld_text,ld_parentid,ld_icon,ld_type)
values (-1110,CURRENT_TIMESTAMP,0,'clustering',2,'clustering.png',1);

alter table ld_user add column ld_ipwhitelist varchar(4000);
alter table ld_user add column ld_ipblacklist varchar(4000);

alter table ld_document add column ld_transactionid varchar(255);
alter table ld_document add column ld_tgs varchar(1000);
alter table ld_version add column ld_transactionid varchar(255);


create table hibernate_unique_key (tablename varchar(40) NOT NULL, next_hi bigint NOT NULL DEFAULT 100);

insert into hibernate_unique_key(tablename, next_hi) select 'ld_document', max(ld_id)+1 from ld_document;
insert into hibernate_unique_key(tablename, next_hi) select 'ld_bookmark', max(ld_id)+1 from ld_bookmark;
insert into hibernate_unique_key(tablename, next_hi) select 'ld_generic', max(ld_id)+1 from ld_generic;
insert into hibernate_unique_key(tablename, next_hi) select 'ld_group', max(ld_id)+1 from ld_group;
insert into hibernate_unique_key(tablename, next_hi) select 'ld_history', max(ld_id)+1 from ld_history;
insert into hibernate_unique_key(tablename, next_hi) select 'ld_link', max(ld_id)+1 from ld_link;
insert into hibernate_unique_key(tablename, next_hi) select 'ld_menu', max(ld_id)+1 from ld_menu;
insert into hibernate_unique_key(tablename, next_hi) select 'ld_systemmessage', max(ld_id)+1 from ld_systemmessage;
insert into hibernate_unique_key(tablename, next_hi) select 'ld_template', max(ld_id)+1 from ld_template;
insert into hibernate_unique_key(tablename, next_hi) select 'ld_ticket', max(ld_id)+1 from ld_ticket;
insert into hibernate_unique_key(tablename, next_hi) select 'ld_user', max(ld_id)+1 from ld_user;
insert into hibernate_unique_key(tablename, next_hi) select 'ld_user_history', max(ld_id)+1 from ld_user_history;
insert into hibernate_unique_key(tablename, next_hi) select 'ld_userdoc', max(ld_id)+1 from ld_userdoc;
insert into hibernate_unique_key(tablename, next_hi) select 'ld_version', max(ld_id)+1 from ld_version;
insert into hibernate_unique_key(tablename, next_hi) select 'ld_folder', max(ld_id)+1 from ld_folder;
insert into hibernate_unique_key(tablename, next_hi) select 'ld_folder_history', max(ld_id)+1 from ld_folder_history;
insert into hibernate_unique_key(tablename, next_hi) select 'ld_feedmessage', max(ld_id)+1 from ld_feedmessage;
insert into hibernate_unique_key(tablename, next_hi) select 'ld_rating', max(ld_id)+1 from ld_rating;
insert into hibernate_unique_key(tablename, next_hi) select 'ld_note', max(ld_id)+1 from ld_note;
insert into hibernate_unique_key(tablename, next_hi) select 'ld_audit', max(ld_id)+1 from ld_audit;
insert into hibernate_unique_key(tablename, next_hi) select 'ld_emailaccount', max(ld_id)+1 from ld_emailaccount;
insert into hibernate_unique_key(tablename, next_hi) select 'ld_archive', max(ld_id)+1 from ld_archive;
insert into hibernate_unique_key(tablename, next_hi) select 'ld_share', max(ld_id)+1 from ld_share;
insert into hibernate_unique_key(tablename, next_hi) select 'ld_workflowtemplate', max(ld_id)+1 from ld_workflowtemplate;
insert into hibernate_unique_key(tablename, next_hi) select 'ld_workflowhistory', max(ld_id)+1 from ld_workflowhistory;
insert into hibernate_unique_key(tablename, next_hi) values ('ld_messagetemplate', 100);


--Change the tagstring convention
update ld_version set ld_tgs = replace(ld_tgs, ' ', '') where not ld_tgs = '' and ld_tgs is not null;
update ld_version set ld_tgs = concat(',', concat(ld_tgs,',')) where not ld_tgs = '' and ld_tgs is not null;
update ld_document A, ld_version B
   set A.ld_tgs = B.ld_tgs 
 where A.ld_id=B.ld_documentid and A.ld_version=B.ld_version;
 

--Add new business objects
create table ld_messagetemplate (ld_id bigint not null, ld_lastmodified timestamp not null, 
                                 ld_deleted int not null, ld_name varchar(255) not null, ld_language varchar(10) not null,
                                 ld_description varchar(1000), ld_body varchar(4000),
                                 ld_subject varchar(1000), primary key (ld_id));
create unique index  AK_MSGTEMPL on ld_messagetemplate (ld_name, ld_language);
insert into ld_messagetemplate (ld_id, ld_lastmodified, ld_deleted, ld_name, ld_language, ld_subject, ld_body)
values(1, CURRENT_TIMESTAMP,0,'task.report','en', '$_task',
'$_task
$startedon: $_started
$finishedon: $_ended
-----------------------------------
#if( $_error )
$error: $_error
-----------------------------------
#end
$_report');
insert into ld_messagetemplate (ld_id, ld_lastmodified, ld_deleted, ld_name, ld_language, ld_subject, ld_body)
values(2, CURRENT_TIMESTAMP,0,'psw.rec1','en', '$_product - $emailnotifyaccountobject', '$_message');
insert into ld_messagetemplate (ld_id, ld_lastmodified, ld_deleted, ld_name, ld_language, ld_subject, ld_body)
values(3, CURRENT_TIMESTAMP,0,'psw.rec2','en', '$_product - $passwordrequest',
'$_product - $passwordrequest
$clickhere: $_url');
insert into ld_messagetemplate (ld_id, ld_lastmodified, ld_deleted, ld_name, ld_language, ld_subject, ld_body)
values(50, CURRENT_TIMESTAMP,0,'audit','en', '$_product - $_eventshort - $_title',
'$title: $_title
$path: $_path
$event: $_event
$user: $_user
$date: $_date
$comment: $_comment
$version: $_version
$url: $_url');
insert into ld_messagetemplate (ld_id, ld_lastmodified, ld_deleted, ld_name, ld_language, ld_subject, ld_body)
values(60, CURRENT_TIMESTAMP,0,'impex.arc','en',
'$_product - #if($_status=="4" ) $badarchive  #else #if($_type=="0") $archivefinalized #else $archivereadytosign #end #end',
'$_message');
insert into ld_messagetemplate (ld_id, ld_lastmodified, ld_deleted, ld_name, ld_language, ld_subject, ld_body)
values(61, CURRENT_TIMESTAMP,0,'impex.inc','en',
'$_product - #if($_type=="0") $archiveclosed #else $archivereadytoclose #end',
'$_message');
insert into ld_messagetemplate (ld_id, ld_lastmodified, ld_deleted, ld_name, ld_language, ld_subject, ld_body)
values(70, CURRENT_TIMESTAMP,0,'wf.assign','en', '$_product - $_task',
'$dear $_assignee, $youareassignedtotask $_task');
insert into ld_messagetemplate (ld_id, ld_lastmodified, ld_deleted, ld_name, ld_language, ld_subject, ld_body)
values(71, CURRENT_TIMESTAMP,0,'wf.remind','en', '$_product - $_task',
'$dear $_assignee, $pleasecompletetask $_task');



alter table ld_systemmessage drop column ld_red;
alter table ld_recipient add column ld_read int default 1;

-- All documents need to be reindexed
update ld_document set ld_indexed=0 where ld_indexed=1;